// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"
	io "io"

	mock "github.com/stretchr/testify/mock"

	tfjson "github.com/hashicorp/terraform-json"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Plan is an autogenerated mock type for the Plan type
type Plan struct {
	mock.Mock
}

// DownloadPlanCache provides a mock function with given fields: ctx, id, writer
func (_m *Plan) DownloadPlanCache(ctx context.Context, id string, writer io.WriterAt) error {
	ret := _m.Called(ctx, id, writer)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, io.WriterAt) error); ok {
		r0 = rf(ctx, id, writer)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// UpdatePlan provides a mock function with given fields: ctx, input
func (_m *Plan) UpdatePlan(ctx context.Context, input *types.UpdatePlanInput) (*types.Plan, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Plan
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdatePlanInput) (*types.Plan, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdatePlanInput) *types.Plan); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Plan)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdatePlanInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadPlanCache provides a mock function with given fields: ctx, id, body
func (_m *Plan) UploadPlanCache(ctx context.Context, id string, body io.Reader) error {
	ret := _m.Called(ctx, id, body)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, io.Reader) error); ok {
		r0 = rf(ctx, id, body)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// UploadPlanData provides a mock function with given fields: ctx, id, tfPlan, tfProviderSchemas
func (_m *Plan) UploadPlanData(ctx context.Context, id string, tfPlan *tfjson.Plan, tfProviderSchemas *tfjson.ProviderSchemas) error {
	ret := _m.Called(ctx, id, tfPlan, tfProviderSchemas)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, *tfjson.Plan, *tfjson.ProviderSchemas) error); ok {
		r0 = rf(ctx, id, tfPlan, tfProviderSchemas)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewPlan interface {
	mock.TestingT
	Cleanup(func())
}

// NewPlan creates a new instance of Plan. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewPlan(t mockConstructorTestingTNewPlan) *Plan {
	mock := &Plan{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
